## opencascade 7.3.0+dfsg1

=== src/TKSTEPAttr/CMakeLists.txt ===
project(TKSTEPAttr)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)

=== tools/TKTInspector/CMakeLists.txt ===
project(TKTInspector)

set (INSTALL_API ON)

OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit_prepare_tool)
OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit)
OCCT_INCLUDE_CMAKE_FILE (adm/cmake/occt_toolkit_prepare_tool)

unset (INSTALL_API)

=== debian/changelog ===
opencascade (7.3.0+dfsg1-5~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 29 Apr 2019 19:38:06 -0700

opencascade (7.3.0+dfsg1-5) unstable; urgency=medium

  * [05357f5] Use opencascade instead of occt for installation paths
    (Closes: #920798)
  * [0ad19ce] Remove unneeded CMake flags

 -- Kurt Kremitzki <kurt@kwk.systems>  Tue, 19 Feb 2019 13:38:38 -0600

opencascade (7.3.0+dfsg1-4) unstable; urgency=medium

  * Drop .symbols files -- they are simply not sustainable. (Closes: #911554)
  * Bump S-V to 4.2.1 -- Add Rules-Requires-Root: no.

 -- Tobias Frost <tobi@debian.org>  Tue, 23 Oct 2018 22:50:46 +0200

opencascade (7.3.0+dfsg1-3) unstable; urgency=medium

  * Upload to unstable.
  * Import symbols for powerpcspe.
  * Bump S-V to 4.1.4 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Wed, 27 Jun 2018 08:13:20 +0200

opencascade (7.3.0+dfsg1-2) experimental; urgency=medium

  [ Tobias Frost ]
  * Import symbols for 7.3.0 from buildlogs for archs:
      alpha arm64 armel armhf i386 m68k mips mips64el mipsel powerpc ppc64
      ppc64el s390x sh4

  [ Kurt Kremitzki ]
  * Add patch to enable exception handling.

 -- Tobias Frost <tobi@debian.org>  Sat, 23 Jun 2018 12:27:11 +0200

opencascade (7.3.0+dfsg1-1) experimental; urgency=medium

  * New upstream release.
    - Remove patch glibc-xlocale.diff, applied upstream.
    - Refresh remaining patches to remove fuzz.
    - As the so-name is now 7.3, rename library packages and adapt package
      accordingly.
    - Remove no longer existing files from the *.install files and add the new
      ones as well.
    - symbols-files: Remove symbols that are no longer in the libs for 7.3.0.
  * Import symbols for powerpcspe from the 7.2.0+dfsg1-5 build.

 -- Tobias Frost <tobi@debian.org>  Sun, 10 Jun 2018 00:51:46 +0200

opencascade (7.2.0+dfsg1-5) experimental; urgency=medium

  * Fix symbols for alpha, armel, mipsel64, mips and sh4.
  * Add coprright clarification for the derived files originally from RINA
    S.p.A.

 -- Tobias Frost <tobi@debian.org>  Sun, 27 May 2018 20:19:10 +0200

opencascade (7.2.0+dfsg1-4) experimental; urgency=medium

  * Add patch to fix FTBFS on armel by not enforcing the atomic requirement.
  * Fix symbols for arm64, armhf, mipsel, powerpc, ppc64, ppc64el and s390.

 -- Tobias Frost <tobi@debian.org>  Sun, 27 May 2018 00:38:51 +0200

opencascade (7.2.0+dfsg1-3) experimental; urgency=medium

  * Fix FTBFS due to indep/arch issues.

 -- Tobias Frost <tobi@debian.org>  Sat, 26 May 2018 16:53:26 +0200

opencascade (7.2.0+dfsg1-2) experimental; urgency=medium

  * Working on the symbols, utilizing pkgkde_symbolshelper to gernerate
    thesymbols file.
      - that needs a B-D on it and a tweak on d/rules.
      - after running the helpers manually on amd64, add those symbols file.
        I keep it mangled for the moment to easier import the other archs.
      - importing i386 symbols from a local pbuilder build.

 -- Tobias Frost <tobi@debian.org>  Sat, 26 May 2018 12:50:39 +0200

opencascade (7.2.0+dfsg1-1) experimental; urgency=low

  [ Kurt Kremitzki ]
  * Reintroducing package (Closes: #882761)
  * New upstream release; software now uses LGPL license
    instead of nonfree license which was the cause of the
    previous version's (6.5.0) removal.
  * Upstream now refers to this library as OCCT and so a naming scheme of
    libocct-* has been implemented for the packages.
  * In accordance with upstream, split libocct-modeling into
    libocct-modeling-algorithms and libocct-modeling-data
  * Improved package short descriptions.
  * Removed debian/README.Debian.html and debian/README.source
  * Removed non-applicable patches and cruft
  * Bumped compat level to 11 and added dep3 headers to patches.
  * Updated VCS-Git info in d/control to point at salsa.d.o
  * Renamed upstream DRAWEXE to occt-draw, which is symlinked
    via new occt-draw.links file from /usr/bin/occt-draw-7.2
    in alignment with upstream's deployment of DRAWEXE
  * Updated debian/*.install to include new files
  * Corrected git branch format
  * Added libocct-doc package for upstream Doxygen HTML documentation
  * Split occt-draw package into shared library, -dev, and binary packages
  * Updated lintian-overrides where appropriate
  * Added experimental d/watch file tracking upstream Gitweb site

  [ Tobias Frost ]
  * Extend d/watch for repacking filename mangling.
  * Add myself as uploader.

 -- Kurt Kremitzki <kkremitzki@gmail.com>  Sat, 31 Mar 2018 09:04:17 +0000

=== debian/control ===
Source: opencascade
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kurt Kremitzki <kkremitzki@gmail.com>, Tobias Frost <tobi@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper(>=11),
               dh-exec,
               libfreeimage-dev,
               libfreetype6-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libtbb-dev,
               libx11-dev,
               libxext-dev,
               libxi-dev,
               libxmu-dev,
               pkg-kde-tools,
               tcl-dev,
               tk-dev
Build-Depends-Indep: doxygen,
                     graphviz
Standards-Version: 4.2.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/opencascade
Vcs-Git: https://salsa.debian.org/science-team/opencascade.git
Homepage: https://www.opencascade.com/

Package: libocct-foundation-7.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: OCCT module underlying all other OCCT classes
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains foundation classes which provide a variety of
 general-purpose services such as automated management of heap memory,
 exception handling, classes for manipulating aggregates of data, basic
 math tools.
 .
 This package contains the following shared libraries:
   TKernel TKMath

Package: libocct-foundation-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libocct-foundation-7.3 (<< ${binary:Version}+1~),
         libocct-foundation-7.3 (>= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboce-foundation-dev
Replaces: liboce-foundation-dev
Description: Open CASCADE Technology module underlying all other OCCT classes - dev files
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 libocct-foundation.

Package: libocct-modeling-data-7.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open CASCADE Technology 2D/3D geometric primitives data structures
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package supplies data structures to represent 2D and 3D geometric models.
 .
 This package contains the following shared libraries:
   TKG2d TKG3d TKGeomBase TKBRep

Package: libocct-modeling-data-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libocct-foundation-dev (<< ${binary:Version}+1~),
         libocct-foundation-dev (>= ${binary:Version}),
         libocct-modeling-data-7.3 (<< ${binary:Version}+1~),
         libocct-modeling-data-7.3 (>= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboce-modeling-dev
Replaces: liboce-modeling-dev
Description: Open CASCADE Technology 2D/3D geometric primitives data structures - dev files
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 libocct-modeling-data.

Package: libocct-modeling-algorithms-7.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open CASCADE Technology geometrical & topological algorithms module
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains the following shared libraries:
   TKGeomAlgo TKTopAlgo TKPrim TKBO TKBool TKHLR TKFillet TKOffset TKFeat
   TKMesh TKXMesh TKShHealing

Package: libocct-modeling-algorithms-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libocct-foundation-dev (<< ${binary:Version}+1~),
         libocct-foundation-dev (>= ${binary:Version}),
         libocct-modeling-algorithms-7.3 (<< ${binary:Version}+1~),
         libocct-modeling-algorithms-7.3 (>= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboce-modeling-dev
Replaces: liboce-modeling-dev
Description: Open CASCADE Technology geometrical & topological algorithms module - dev files
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 libocct-modeling-algorithms.

Package: libocct-visualization-7.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open CASCADE Technology graphical data visualization module
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package provides services for displaying 2D and 3D graphics.
 .
 This package contains the following shared libraries:
  TKService TKV3d TKOpenGl TKMeshVS TKIVtk TKD3DHost

Package: libocct-visualization-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libfreeimage-dev,
         libfreetype6-dev,
         libgl1-mesa-dev | libgl-dev,
         libglu1-mesa-dev | libglu-dev,
         libocct-foundation-dev (<< ${binary:Version}+1~),
         libocct-foundation-dev (>= ${binary:Version}),
         libocct-modeling-algorithms-dev (<< ${binary:Version}+1~),
         libocct-modeling-algorithms-dev (>= ${binary:Version}),
         libocct-modeling-data-dev (<< ${binary:Version}+1~),
         libocct-modeling-data-dev (>= ${binary:Version}),
         libocct-ocaf-dev (<< ${binary:Version}+1~),
         libocct-ocaf-dev (>= ${binary:Version}),
         libocct-visualization-7.3 (<< ${binary:Version}+1~),
         libocct-visualization-7.3 (>= ${binary:Version}),
         libx11-dev,
         libxext-dev,
         libxmu-dev,
         ${misc:Depends}
Conflicts: liboce-visualization-dev
Replaces: liboce-visualization-dev
Description: Open CASCADE Technology graphical data visualization module - dev files
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 libocct-visualization.

Package: libocct-ocaf-7.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open CASCADE Technology application-specific data and functionality
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package provides Open CASCADE Application Framework services.
 .
 This package contains the following shared libraries:
 .
   TKCDF TKLCAF TKCAF TKBinL TKXmlL TKBin TKXml TKStdL TKStd TKTObj TKBinTObj
   TKXmlTObj TKVCAF

Package: libocct-ocaf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libocct-foundation-dev (<< ${binary:Version}+1~),
         libocct-foundation-dev (>= ${binary:Version}),
         libocct-modeling-algorithms-dev (<< ${binary:Version}+1~),
         libocct-modeling-algorithms-dev (>= ${binary:Version}),
         libocct-modeling-data-dev (<< ${binary:Version}+1~),
         libocct-modeling-data-dev (>= ${binary:Version}),
         libocct-ocaf-7.3 (<< ${binary:Version}+1~),
         libocct-ocaf-7.3 (>= ${binary:Version}),
         libocct-visualization-7.3 (<< ${binary:Version}+1~),
         libocct-visualization-7.3 (>= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboce-ocaf-dev, liboce-ocaf-lite-dev
Replaces: liboce-ocaf-dev, liboce-ocaf-lite-dev
Description: Open CASCADE Technology application-specific data and functionality - dev files
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package contains the headers and symlinks for libraries shipped by
 libocct-ocaf.

Package: libocct-data-exchange-7.3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Open CASCADE Technology module for CAD data format interoperability
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .
 This package provides support for data exchange.
 .
 This package contains the following shared libraries:
   TKXSBase TKSTEPBase TKSTEPAttr TKSTEP209 TKSTEP TKIGES TKXCAF TKXDEIGES
   TKXDESTEP TKSTL TKVRML TKXmlXCAF TKBinXCAF

Package: libocct-data-exchange-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libocct-data-exchange-7.3 (<< ${binary:Version}+1~),
         libocct-data-exchange-7.3 (>= ${binary:Version}),
         libocct-foundation-dev (<< ${binary:Version}+1~),
         libocct-foundation-dev (>= ${binary:Version}),
         libocct-modeling-algorithms-dev (<< ${binary:Version}+1~),
         libocct-modeling-algorithms-dev (>= ${binary:Version}),
         libocct-modeling-data-dev (<< ${binary:Version}+1~),
         libocct-modeling-data-dev (>= ${binary:Version}),
         libocct-ocaf-dev (<< ${binary:Version}+1~),
         libocct-ocaf-dev (>= ${binary:Version}),
         libocct-visualization-dev (<< ${binary:Version}+1~),
         libocct-visualization-dev (>= ${binary:Version}),
         ${misc:Depends}
Conflicts: liboce-ocaf-dev, liboce-ocaf-lite-dev
Replaces: liboce-ocaf-dev, liboce-ocaf-lite-dev
Description: Open CASCADE Technology module for CAD data format interoperability - dev files
 Open CASCADE Technology is a suite for 3D surface and solid modeling,
 visualization, data exchange and rapid application development.  It is an
 excellent platform for development of numerical simulation software including
 CAD/CAM/CAE, AEC and GIS, as well as PDM applications.
 .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS   := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CPPFLAGS) $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS  := $(shell dpkg-buildflags --get LDFLAGS)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --buildsystem=cmake --with=pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
        -DFREETYPE_INCLUDE_DIR=/usr/include/freetype2 \
        -DINSTALL_CMAKE_DATA_DIR:PATH=lib/$(DEB_HOST_MULTIARCH)/opencascade \
        -DINSTALL_DIR_LIB:PATH=lib/$(DEB_HOST_MULTIARCH) \
	-DUSE_VTK:BOOL=off \
	-DUSE_TBB:BOOL=on \
	-DUSE_FREEIMAGE:BOOL=on \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	$(if $(findstring $(DEB_BUILD_ARCH),armel),-DIGNORE_NO_ATOMICS:BOOL=on)

override_dh_installdocs-indep:
	dh_installdocs
	dh_doxygen

override_dh_missing-arch:
	dh_missing --fail-missing

override_dh_shlibdeps:
	# Disable unnecessary warnings happening because of the way the packages
	# provide their shared libraries, see d/control
	dh_shlibdeps -- --warnings=1

override_dh_strip:
	dh_strip --no-automatic-dbgsym

## opencascade 7.3.3%2Bdfsg1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12 FATAL_ERROR)

set (CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/adm/cmake")

set (CMAKE_SUPPRESS_REGENERATION TRUE)

set (CMAKE_CONFIGURATION_TYPES Release Debug RelWithDebInfo CACHE INTERNAL "" FORCE)

# macro: include patched file if it exists
macro (OCCT_INCLUDE_CMAKE_FILE BEING_INCLUDED_FILE)
  if (BUILD_PATCH AND EXISTS "${BUILD_PATCH}/${BEING_INCLUDED_FILE}.cmake")
    include (${BUILD_PATCH}/${BEING_INCLUDED_FILE}.cmake)
  else()
    include (${CMAKE_SOURCE_DIR}/${BEING_INCLUDED_FILE}.cmake)
  endif()
endmacro()

# include variable description
OCCT_INCLUDE_CMAKE_FILE ("adm/cmake/vardescr")

# set type of OCCT libraries
if (NOT BUILD_LIBRARY_TYPE)
  set (BUILD_LIBRARY_TYPE "Shared" CACHE STRING "${BUILD_LIBRARY_TYPE_DESCR}" FORCE)
  SET_PROPERTY(CACHE BUILD_LIBRARY_TYPE PROPERTY STRINGS Shared Static)
endif()

if ("${BUILD_LIBRARY_TYPE}" STREQUAL "Shared")
  set (BUILD_SHARED_LIBS ON)

  if (NOT DEFINED BUILD_SHARED_LIBRARY_NAME_POSTFIX)
    set (BUILD_SHARED_LIBRARY_NAME_POSTFIX "" CACHE STRING "${BUILD_SHARED_LIBRARY_NAME_POSTFIX_DESCR}" FORCE)
  endif()
else()
  unset (BUILD_SHARED_LIBS)
  unset (BUILD_SHARED_LIBRARY_NAME_POSTFIX)
endif()

# the name of the project
project (OCCT)

if (WIN32)
  add_definitions(-DUNICODE)
  add_definitions(-D_UNICODE)
endif()

# include occt macros
OCCT_INCLUDE_CMAKE_FILE ("adm/cmake/occt_macros")

# Solution folder property
set_property (GLOBAL PROPERTY USE_FOLDERS ON)

# get current OCCT version
OCC_VERSION (OCC_VERSION_MAJOR OCC_VERSION_MINOR OCC_VERSION_MAINTENANCE OCC_VERSION_DEVELOPMENT OCC_VERSION_STRING_EXT)

set_property (GLOBAL PROPERTY OCC_VERSION_MAJOR ${OCC_VERSION_MAJOR})
set_property (GLOBAL PROPERTY OCC_VERSION_MINOR ${OCC_VERSION_MINOR})
set_property (GLOBAL PROPERTY OCC_VERSION_MAINTENANCE ${OCC_VERSION_MAINTENANCE})

set (INSTALL_TEST_CASES OFF CACHE BOOL "${INSTALL_TEST_CASES_DESCR}")

# Regeneration of OCCT resource files
set (BUILD_RESOURCES OFF CACHE BOOL "${BUILD_RESOURCES_DESCR}")

# single-configuration generator
set (SINGLE_GENERATOR OFF)
if (CMAKE_BUILD_TYPE)
  set (SINGLE_GENERATOR ON)
endif()

# a single-configuration generator like the Makefile generator defines CMAKE_BUILD_TYPE variable
# check this variable and set if it's required
if (DEFINED CMAKE_BUILD_TYPE AND NOT CMAKE_BUILD_TYPE) # single-configuration generator.
  set (CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

# enable extended messages of many OCCT algorithms
if (((SINGLE_GENERATOR AND "${CMAKE_BUILD_TYPE}" STREQUAL "Debug") OR NOT SINGLE_GENERATOR) AND (NOT "${CMAKE_SYSTEM_NAME}" STREQUAL "WindowsStore"))
  if (NOT BUILD_WITH_DEBUG)
    set (BUILD_WITH_DEBUG OFF CACHE BOOL "${BUILD_WITH_DEBUG_DESCR}")
  endif()
else()
  OCCT_CHECK_AND_UNSET (BUILD_WITH_DEBUG)
endif()

if (BUILD_WITH_DEBUG)
  set_property(DIRECTORY APPEND PROPERTY COMPILE_DEFINITIONS $<$<CONFIG:DEBUG>:OCCT_DEBUG>)
endif()

# option to enable or disable use of precompiled headers
if (NOT DEFINED BUILD_USE_PCH)
  set (BUILD_USE_PCH OFF CACHE BOOL "${BUILD_USE_PCH_DESCR}")
endif()

if (BUILD_USE_PCH)

  # Load Cotire tool for accelerating build procedure
  include(cotire)

  # Set Cotire to ignore lxx, pxx, gxx 
  set (COTIRE_ADDITIONAL_PREFIX_HEADER_IGNORE_EXTENSIONS "lxx;pxx;gxx" CACHE STRING "Set Cotire to ignore OCCT specific files that can be #included" FORCE)

  # Set priority for inclusion of system headers in PCH to reduce problems
  # due to incomplete inclusion or wrong order.
  if (WIN32)
    # on Windows, assume that SDK (windows.h) is in default location
    set(ProgramFilesX86 "ProgramFiles(x86)")
    file(TO_CMAKE_PATH "$ENV{${ProgramFilesX86}}" ProgramFilesX86)
    set_property (DIRECTORY PROPERTY COTIRE_PREFIX_HEADER_INCLUDE_PRIORITY_PATH "${ProgramFilesX86}")
    unset(ProgramFilesX86)
  endif()

endif()

# copy samples to install directory
set (INSTALL_SAMPLES OFF CACHE BOOL "${INSTALL_SAMPLES_DESCR}")

# install dir of the project
if (NOT DEFINED INSTALL_DIR)
  # set default install directory for Windows
  if (WIN32 AND NOT DEFINED CMAKE_INSTALL_PREFIX)
    set (CMAKE_INSTALL_PREFIX "C:/opencascade-${OCC_VERSION_STRING_EXT}")
  endif()
  set (INSTALL_DIR "${CMAKE_INSTALL_PREFIX}" CACHE PATH "${INSTALL_DIR_DESCR}")
else()
  file (TO_CMAKE_PATH "${INSTALL_DIR}" INSTALL_DIR)
  set (INSTALL_DIR "${INSTALL_DIR}" CACHE PATH "${INSTALL_DIR_DESCR}" FORCE)
endif()

# choose a variant of the layout of the install paths
if (NOT INSTALL_DIR_LAYOUT)
  if (WIN32)
    set (INSTALL_DIR_LAYOUT "Windows" CACHE STRING "${INSTALL_DIR_LAYOUT_DESCR}" FORCE)
  else()
    set (INSTALL_DIR_LAYOUT "Unix" CACHE STRING "${INSTALL_DIR_LAYOUT_DESCR}" FORCE)
  endif()
  SET_PROPERTY(CACHE INSTALL_DIR_LAYOUT PROPERTY STRINGS Windows Unix)
endif()

# check INSTALL_DIR_LAYOUT changes and update INSTALL_DIR_* paths if necessary
if (NOT DEFINED INSTALL_DIR_LAYOUT_PREV)
  set (INSTALL_DIR_LAYOUT_PREV "${INSTALL_DIR_LAYOUT}" CACHE INTERNAL "" FORCE)
elseif (NOT "${INSTALL_DIR_LAYOUT_PREV}" STREQUAL "${INSTALL_DIR_LAYOUT}")
  set (INSTALL_DIR_LAYOUT_PREV "${INSTALL_DIR_LAYOUT}" CACHE INTERNAL "" FORCE)
  # The structure of install folder should be reset due to changed layout
  OCCT_CHECK_AND_UNSET_INSTALL_DIR_SUBDIRS ()

  # Unset INSTALL_DIR_WITH_VERSION on windows
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Windows")
    OCCT_CHECK_AND_UNSET (INSTALL_DIR_WITH_VERSION)
  else()
    if (NOT DEFINED INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_WITH_VERSION OFF CACHE BOOL "${INSTALL_DIR_WITH_VERSION_DESCR}")
    endif()
  endif()
endif()

# check CMAKE_INSTALL_PREFIX changes and update INSTALL_DIR if necessary
if (NOT DEFINED CMAKE_INSTALL_PREFIX_PREV)
  set (CMAKE_INSTALL_PREFIX_PREV "${CMAKE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
elseif (NOT "${CMAKE_INSTALL_PREFIX_PREV}" STREQUAL "${CMAKE_INSTALL_PREFIX}")
  # CMAKE_INSTALL_PREFIX has been changed at previous step
  set (CMAKE_INSTALL_PREFIX_PREV "${CMAKE_INSTALL_PREFIX}" CACHE INTERNAL "" FORCE)
  
  # INSTALL_DIR is required to be updated
  set (INSTALL_DIR "${CMAKE_INSTALL_PREFIX}" CACHE PATH "${INSTALL_DIR_DESCR}" FORCE)
endif()

# check INSTALL_DIR changes and update CMAKE_INSTALL_PREFIX if necessary
if (NOT DEFINED INSTALL_DIR_PREV)
  set (INSTALL_DIR_PREV "${INSTALL_DIR}" CACHE INTERNAL "" FORCE)
elseif (NOT "${INSTALL_DIR_PREV}" STREQUAL "${INSTALL_DIR}")
  # INSTALL_DIR has been changed at previous step
  set (INSTALL_DIR_PREV "${INSTALL_DIR}" CACHE INTERNAL "" FORCE)

  # sync CMAKE_INSTALL_PREFIX with INSTALL_DIR 
  set (CMAKE_INSTALL_PREFIX "${INSTALL_DIR}" CACHE INTERNAL "" FORCE)

  # set CMAKE_INSTALL_PREFIX_PREV to avoid the reset of structure of the install folder 
  set (CMAKE_INSTALL_PREFIX_PREV "${INSTALL_DIR}" CACHE INTERNAL "" FORCE)
endif()

if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
  if (NOT DEFINED INSTALL_DIR_WITH_VERSION_PREV)
    set (INSTALL_DIR_WITH_VERSION_PREV "${INSTALL_DIR_WITH_VERSION}" CACHE INTERNAL "" FORCE)
  elseif (NOT "${INSTALL_DIR_WITH_VERSION_PREV}" STREQUAL "${INSTALL_DIR_WITH_VERSION}")
    # INSTALL_DIR_WITH_VERSION has been changed at previous step
    set (INSTALL_DIR_WITH_VERSION_PREV "${INSTALL_DIR_WITH_VERSION}" CACHE INTERNAL "" FORCE)

    OCCT_CHECK_AND_UNSET_INSTALL_DIR_SUBDIRS ()
  endif()
endif()

# hide CMAKE_INSTALL_PREFIX from a user
set (CMAKE_INSTALL_PREFIX "${INSTALL_DIR}" CACHE INTERNAL "" FORCE)

set (BIN_LETTER "")
if ("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
  set (BIN_LETTER "d")
elseif ("${CMAKE_BUILD_TYPE}" STREQUAL "RelWithDebInfo")
  set (BIN_LETTER "i")
endif()

# Get all used variables: OS_WITH_BIT, COMPILER
OCCT_MAKE_OS_WITH_BITNESS()
OCCT_MAKE_COMPILER_SHORT_NAME()

# do not define INSTALL_DIR_BIN for win.
# Leave library structure for win: <prefix>/win64/vc10/bin(d)
if (NOT DEFINED INSTALL_DIR_BIN)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_BIN "bin" CACHE PATH "${INSTALL_DIR_BIN_DESCR}")
  else()
    set (INSTALL_DIR_BIN "${OS_WITH_BIT}/${COMPILER}/bin" CACHE PATH "${INSTALL_DIR_BIN_DESCR}")
  endif()
endif()

# define folder contaning all shell/batch scripts
if (NOT DEFINED INSTALL_DIR_SCRIPT)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_SCRIPT "${INSTALL_DIR_BIN}" CACHE PATH "${INSTALL_DIR_SCRIPT_DESCR}")
  else()
    set (INSTALL_DIR_SCRIPT "." CACHE PATH "${INSTALL_DIR_SCRIPT_DESCR}")
  endif()
endif()

# place the libraries to <prefix>/lib folder for unix and leave old structure for windows
if (NOT DEFINED INSTALL_DIR_LIB)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_LIB "lib" CACHE PATH "${INSTALL_DIR_LIB_DESCR}")
  else()
    set (INSTALL_DIR_LIB "${OS_WITH_BIT}/${COMPILER}/lib" CACHE PATH "${INSTALL_DIR_LIB_DESCR}")
  endif()
endif()

# OCCT headers: <prefix>/inc for windows,
#               <prefix>/include/opencascade-7.0.0 for unix
if (NOT DEFINED INSTALL_DIR_INCLUDE)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_INCLUDE "include/opencascade" CACHE PATH "${INSTALL_DIR_INCLUDE_DESCR}")
    if (INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_INCLUDE "include/opencascade-${OCC_VERSION_STRING_EXT}" CACHE PATH "${INSTALL_DIR_INCLUDE_DESCR}" FORCE)
    endif()
  else()
    set (INSTALL_DIR_INCLUDE "inc" CACHE PATH "${INSTALL_DIR_INCLUDE_DESCR}")
  endif()
endif()

# OCCT resources: <prefix>/src for windows,
#                 <prefix>/share/opencascade-7.0.0/resources for unix
if (NOT DEFINED INSTALL_DIR_RESOURCE)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_RESOURCE "share/opencascade/resources" CACHE PATH "${INSTALL_DIR_RESOURCE_DESCR}")
    if (INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_RESOURCE "share/opencascade-${OCC_VERSION_STRING_EXT}/resources" CACHE PATH "${INSTALL_DIR_RESOURCE_DESCR}" FORCE)
    endif()
  else()
    set (INSTALL_DIR_RESOURCE "src" CACHE PATH "${INSTALL_DIR_RESOURCE_DESCR}")
  endif()
endif()

# OCCT data
if (NOT DEFINED INSTALL_DIR_DATA)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_DATA "share/opencascade/data" CACHE PATH "${INSTALL_DIR_DATA_DESCR}")
    if (INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_DATA "share/opencascade-${OCC_VERSION_STRING_EXT}/data" CACHE PATH "${INSTALL_DIR_DATA_DESCR}" FORCE)
    endif()
  else()
    set (INSTALL_DIR_DATA "data" CACHE PATH "${INSTALL_DIR_DATA_DESCR}")
  endif()
endif()

# OCCT samples
if (NOT DEFINED INSTALL_DIR_SAMPLES)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_SAMPLES "share/opencascade/samples" CACHE PATH "${INSTALL_DIR_SAMPLES_DESCR}")
    if (INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_SAMPLES "share/opencascade-${OCC_VERSION_STRING_EXT}/samples" CACHE PATH "${INSTALL_DIR_SAMPLES_DESCR}" FORCE)
    endif()
  else()
    set (INSTALL_DIR_SAMPLES "samples" CACHE PATH "${INSTALL_DIR_SAMPLES_DESCR}")
  endif()
endif()

# OCCT tests
if (NOT DEFINED INSTALL_DIR_TESTS)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_TESTS "share/opencascade/tests" CACHE PATH "${INSTALL_DIR_TESTS_DESCR}")
    if (INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_TESTS "share/opencascade-${OCC_VERSION_STRING_EXT}/tests" CACHE PATH "${INSTALL_DIR_TESTS_DESCR}" FORCE)
    endif()
  else()
    set (INSTALL_DIR_TESTS "tests" CACHE PATH "${INSTALL_DIR_TESTS_DESCR}")
  endif()
endif()

# OCCT doc
if (NOT DEFINED INSTALL_DIR_DOC)
  if ("${INSTALL_DIR_LAYOUT}" STREQUAL "Unix")
    set (INSTALL_DIR_DOC "share/doc/opencascade" CACHE PATH "${INSTALL_DIR_DOC_DESCR}")
    if (INSTALL_DIR_WITH_VERSION)
      set (INSTALL_DIR_DOC "share/doc/opencascade-${OCC_VERSION_STRING_EXT}" CACHE PATH "${INSTALL_DIR_DOC_DESCR}" FORCE)
    endif()
  else()
    set (INSTALL_DIR_DOC "doc" CACHE PATH "${INSTALL_DIR_DOC_DESCR}")
  endif()
endif()

# define folder contaning CMake configuration files
if (NOT DEFINED INSTALL_DIR_CMAKE)
